<?php
include_once('lib_my_peers.php');

class block_my_peers extends block_base {
 
  var $default_param;

  function init() {

    global $COURSE, $CFG;

    $this->title = get_string('mypeers', 'block_my_peers');
    $this->version = 2007090300;
    $this->default_param = new stdClass(); 
    $this->default_param->block_my_peers_admin_title = ''; 
    $this->default_param->block_my_peers_admin_blabla = '';
    $this->default_param->block_my_peers_admin_display_role = 1;
    $this->default_param->block_my_peers_admin_by_group = 1;
    $this->default_param->block_my_peers_admin_personnal_info = 0;
    $this->default_param->block_my_peers_admin_photo = 1; 
    $this->default_param->block_my_peers_admin_photo_size = 0; 
    if ($COURSE->defaultrole) {
      $defaultrole = $COURSE->defaultrole; 
    } else {
      $defaultrole = $CFG->defaultcourseroleid; 
    }
    $this->default_param->block_my_peers_role_to_display =   $tab = array( $defaultrole => array( '2' => true, '3' => true, '4' => true));

  }

  function has_config() {
    return true;
  }

  /**
   * This function return the value of the parameter $param_name :
   * if the parameter is set for the block instance return this value
   *  else return the value set on site level
   *  else return false
   */

  function get_param($param_name, $instance = true) {
    global $CFG;

    if (isset($this->config->$param_name) and is_string($this->config->$param_name) and  ! strcmp($this->config->$param_name,'')) {
      unset($this->config->$param_name);
    }
    if (isset($this->config->$param_name) and $instance) {
      return $this->config->$param_name;
    } else {
      if (isset($CFG->$param_name)) {
    return $CFG->$param_name;
      } else {
    return $this->default_param->$param_name;;
      }
    }
  } 

  /**
  * This function display personns with role wanted  wich belong the group with the $group identifiant
  * If $group is false, display all personns with role wanted.
  * Return an array of user object
  */  
  function get_and_display_persons( $group ) {
    
    global $USER, $CFG, $COURSE;
    
    global $switchrole;

    $persons = array();
    
    // get the role to display ( saved in a block parameter)
    $roles_to_display = $this->get_param('block_my_peers_role_to_display');

    if ($COURSE->id == SITEID) {
        $coursecontext = get_context_instance(CONTEXT_SYSTEM, SITEID);   // SYSTEM context
    } else {
        $coursecontext = get_context_instance(CONTEXT_COURSE, $COURSE->id);   // Course context
    }

    if (isloggedin()) {
      $usercontext   = get_context_instance(CONTEXT_USER, $USER->id);       // User context
    }
    

    $userroles = array();
    
    // Verification if there is a role switching to use an other role that the current role
    if ($switchrole > 0) {
      $userrole = get_record('role', 'id', $switchrole);
      //role_switch($switchrole, $coursecontext);
      $userroles[]->roleid=$userrole->id;
    } else {
      // Get the role in the course of current user. 
      $userroles = get_user_roles($coursecontext);
      }

    // make sure user can view this user's profile
    $details = true;
    if ( !has_capability('moodle/user:viewdetails', $coursecontext) 
        || !has_capability('moodle/user:viewdetails', $usercontext)) {
      $details = false;
    }

    $rolesids = array();
    // Search for each role of the current user, persons we have to display 
   foreach($userroles as $userrole) {
      if (! empty($roles_to_display[$userrole->roleid])) {
            foreach($roles_to_display[$userrole->roleid] as $roleid => $tps) {
                if ($group ) { 
                    $persons_tmp = get_role_users($roleid, $coursecontext, true, '', 'u.lastname ASC', false, $group->id);
                 } else {
                     $persons_tmp = get_role_users($roleid, $coursecontext, true, '', 'u.lastname ASC', false);
                 }
                 if (!empty ($persons_tmp)) {
                 foreach($persons_tmp as $ptp) {
                     $rolename = role_fix_names(array($ptp->roleid => $ptp->rolename), $coursecontext);
                     if(! isset($persons[$ptp->id]) ){
                         $persons[$ptp->id] = $ptp;
                         $persons[$ptp->id]->rolename = $rolename[$ptp->roleid];
                     } else {
                         $persons[$ptp->id]->rolename .= ','.$rolename[$ptp->roleid];
                         }
                      
                 }
   }
}

        }
    }    
    
    
    // Display 
 
   $text = '';
    if(!empty($persons)) {

      // creation of the list of id to have no double
  //    $list_id = array();
      foreach ($persons as $person) {
    /*if ( isset($list_id[$person->id]) ) {
      // The person has been already displayed, so not again 
        continue;
    } else {
      $list_id[$person->id]=true;
    }*/


    if ( $this->get_param('block_my_peers_admin_photo') < 2 ) {
      $text .= "<div>";
    }

    if ($this->get_param('block_my_peers_admin_photo')) {

      $text .= my_peers_print_user_picture($person->id, $COURSE->id, $person->picture, $this->get_param('block_my_peers_admin_photo_size'), true, $details,'',fullname($person));

    }
    if ( $this->get_param('block_my_peers_admin_photo') == 2 ) {
      continue;
    }
      if ($details) {
        $text .= '<br /><strong><a href="'.$CFG->wwwroot.'/user/view.php?id='.$person->id.'&amp;course='.$COURSE->id.'">'.fullname($person).'</a></strong>';
      } else {
        $text .= '<br /><strong>'.fullname($person).'</strong>';
      }

      $role = '';
      if ($this->get_param('block_my_peers_admin_display_role')) {
      //$role = get_user_roles_in_context($person->id, $coursecontext);
      $role = $person->rolename;
      }
      if ($this->get_param('block_my_peers_admin_personnal_info')) {
        
        if (! $user = get_record("user", "id", $person->id)) {
          error("User ID was incorrect");
        }
      
        $hiddenfields = array_flip(explode(',', $CFG->hiddenuserfields));
        
        if ($user->description && !isset($hiddenfields['descriptionid'])) {
          $text .= '<div>'.($user->description).'</div><br />';
        } 

        $text .= " ".'<a title="'.get_string('messageselectadd').'" href="'.$CFG->wwwroot.'/message/discussion.php?id='.$person->id.'" onclick="return openpopup(\'/message/discussion.php?id='.$person->id.'\', \'message_'.$person->id.'\', \'menubar=0,location=0,scrollbars,status,resizable,width=400,height=500\', 0);">'
        .'<img class="icon message" src="'.$CFG->pixpath.'/t/message.gif" alt="'. get_string('messageselectadd') .'" />'.get_string('sendmessage', 'message').'</a><br />'.$role.' ';
      $text .= "</div>";

        if ($user->maildisplay == 1 or
        ($user->maildisplay == 2 and ($COURSE->id != SITEID) and !isguest()) or
        has_capability('moodle/course:useremail', $coursecontext)) {
          $text .=  '<div>'.get_string('addemail', 'block_my_peers').':&nbsp;'.obfuscate_mailto($user->email, get_string('email'), $user->emailstop).'</div>';
        }
        
        if ($user->url && !isset($hiddenfields['webpage'])) {
            $url = $user->url;
            if (strpos($user->url, '://') === false) {
            $url = 'http://'. $url;
            }
          $text .= "<div><a href=\"$url\">".get_string('webpage')."</a></div>";
        }

        if ($user->icq && !isset($hiddenfields['icqnumber'])) {
          $text .= "<div><a href=\"http://web.icq.com/wwp?uin=$user->icq\">".get_string('icqnumber')." <img src=\"http://web.icq.com/whitepages/online?icq=$user->icq&amp;img=5\" width=\"18\" height=\"18\" alt=\"\" /></a></div>";
        }
        
        if ($user->skype && !isset($hiddenfields['skypeid'])) {
          $text .= '<div><a href="callto:'.urlencode($user->skype).'">'.get_string('skypeid').' <img src="http://mystatus.skype.com/smallicon/'.urlencode($user->skype).'" alt="status" '.
        ' height="16" width="16" /></a></div>';
        }
        /*****
        if ($user->yahoo && !isset($hiddenfields['yahooid'])) {
          $text .= '<div><a href="http://edit.yahoo.com/config/send_webmesg?.target='.urlencode($user->yahoo).'&amp;.src=pg">'."Yahoo <img src=\"http://opi.yahoo.com/online?u=".urlencode($user->yahoo)."&m=g&t=0\" width=\"12\" height=\"12\" alt=\"\"></a></div>";
        }
        if ($user->aim && !isset($hiddenfields['aimid'])) {
          $text .=  '<div><a href="aim:goim?screenname='.'">AIM</a></div>';
        }
        if ($user->msn && !isset($hiddenfields['msnid'])) {
          $text .= '<div>MSN:'.s($user->msn).'</div>';
        }
        *********/
        if ($user->phone1 && !isset($hiddenfields['phone1id'])) {
          $text .= "<div>".get_string('phone').s($user->phone1).'</div>';
        }
        if ($user->phone2 && !isset($hiddenfields['phone2id'])) {
          $text .= "<div>".get_string('phone2').s($user->phone2).'</div>';
        }
      }
      }
    } else {
      // Do nothing : $text is empty;
    }
    return $text;
  }
  


  function get_content() {
    global $USER, $CFG, $COURSE;
    
    if ($this->content !== NULL) {
      return $this->content;
    }
    
    $this->content = new stdClass;
    $this->content->text = '';
    $this->content->footer = '';

    
    if (empty($this->instance)) {
      return $this->content;
    }
    
    $groups = array();

    if ($COURSE->id == SITEID) {
        $coursecontext = get_context_instance(CONTEXT_SYSTEM, SITEID);   // SYSTEM context
    } else {
        $coursecontext = get_context_instance(CONTEXT_COURSE, $COURSE->id);   // Course context
    }


    // Have a look If the user can see all people or only his group
    // If he can see only his group, force the  block_my_peers_admin_by_group to be 1
    // I don't integrate the capability 'moodle/site:accessallgroups' because I don't understand yet how it works
    //  (! has_capability('moodle/site:accessallgroups',$coursecontext)

    if  (($COURSE->groupmode == SEPARATEGROUPS and $COURSE->groupmodeforce) ) {
      $force_by_group = true;
      $this->config->block_my_peers_admin_by_group = 1;
    } else {
      $force_by_group = false;
      if  (($COURSE->groupmode == NOGROUPS and $COURSE->groupmodeforce) ) {
      $this->config->block_my_peers_admin_by_group = 0;
      } 
    }

    if ( $this->get_param('block_my_peers_admin_by_group')  ) {
      $groups =  get_groups($COURSE->id,$USER->id);
    }

    $text = '';
    if ($groups) {
      foreach( $groups as $groupid => $group) {    
    $text_group = $this->get_and_display_persons($group);
    if ($text_group) $text .= ' <a href="'.$CFG->wwwroot.'/user/index.php?id='.$COURSE->id.'&amp;group='.$group->id.'">'.$group->name.'</a><hr />'.$text_group;
      }
    } elseif (! $force_by_group) {
      $text .= $this->get_and_display_persons(false);
    }

    // Footer is added only if there somebody to display
    if ($text) $this->content->footer= $this->get_param('block_my_peers_admin_blabla');
    $this->content->text = $text ;
    
    return $this->content;     
  }
  

  function applicable_formats() {
    return array('site-index' => false,
         'course' => true, 
         'mod' => true );
         }
  

  function specialization() {
    global $CFG;
    
    if ($this->get_param('block_my_peers_admin_title') ) {
      $this->title = $this->get_param('block_my_peers_admin_title');
    } else {
      $this->title = get_string('mypeers', 'block_my_peers');
    }


  }

  function instance_allow_config() {
    return true;
  }
  
}
?>
